﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Ext.Net;

namespace SoftCo
{
    public partial class TestAutoBindGrid : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (true)
            {

            }
        }

        protected void BindData_Click(object sender, DirectEventArgs e)
        {
            var rowCount = new Random().Next(10, 20);
            var colCount = new Random().Next(20, 40);
            DataTable dt = new DataTable();
            for (int i = 0; i < rowCount; i++)
            {
                var dr = dt.NewRow();
                for (int j = 0; j < colCount; j++)
                {
                    if (i == 0)
                    {
                        var col = new Random(j).Next(1, 100000).ToString();
                        if (!dt.Columns.Contains(col))
                            dt.Columns.Add(col);
                    }
                    dr[j] = new Random((i + 1) * (j + 2)).Next(1, 100000);
                }
                dt.Rows.Add(dr);
            }
            BindData(dt, gpRPTData, Store1);
        }
        /// <summary>
        /// 生成字段和列，并绑定数据源
        /// </summary>
        /// <param name="_rptData"></param>
        /// <param name="_gp"></param>
        /// <param name="_store"></param>
        private void BindData(DataTable _rptData, GridPanel _gp, Store _store)
        {
            //清除旧数据与记录集
            _store.Reader.Clear();
            _gp.SelectionModel.Clear();
            _gp.ColumnModel.Columns.Clear();
            //_store.Model.Clear();
            var _jsonReader = new JsonReader();
            foreach (DataColumn _dataColumn in _rptData.Columns)
            {
                //创建字段
                _jsonReader.Fields.Add(new RecordField(_dataColumn.ColumnName));
                //创建列
                var _column = new Column
                {
                    Header = Server.HtmlEncode(_dataColumn.ColumnName),
                    DataIndex = _dataColumn.ColumnName,
                };
                _gp.ColumnModel.Columns.Add(_column);
            }
            _store.Reader.Add(_jsonReader);
            _store.DataSource = _rptData.DefaultView;
            _store.DataBind();
            // 重绘【必须调用】
            _gp.Render();
        }
    }
}